/*
 * WiPal - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2007, 2008  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#ifndef WIFI_FRAME_SEQCTL_SOURCE_BSSID_TIMESTAMP_ID_HH_
# define WIFI_FRAME_SEQCTL_SOURCE_BSSID_TIMESTAMP_ID_HH_

# include <wipal/wifi/timestamp.hh>
# include <wipal/wifi/frame/unique_id/unique_id.hh>

namespace wifi
{

  namespace frame
  {

    namespace internals
    {

      struct seq_src_bss_tmp_tag1 {};
      struct seq_src_bss_tmp_tag2 {};
      struct seq_src_bss_tmp_tag3 {};

    } // End of namespace internals.

    typedef
      unique_id<
        internals::adapter<uint16_t, internals::seq_src_bss_tmp_tag1>,
        internals::adapter<unsigned, internals::seq_src_bss_tmp_tag2>,
        internals::adapter<unsigned, internals::seq_src_bss_tmp_tag3>,
        timestamp>
      seq_src_bss_tmp_id;

    template <>
    struct unique_id_factory<seq_src_bss_tmp_id>
    {
      template <class HeaderType, class D>
      boost::optional<seq_src_bss_tmp_id>
      build(const pcapxx::frame_descriptor<D>&	desc,
	    addr_mapping&			mapping);
    };

  } // End of namespace wifi::frame.

} // End of namespace wifi.

# include "seqctl_source_bssid_timestamp.hxx"

#endif // ! WIFI_FRAME_SEQCTL_SOURCE_BSSID_TIMESTAMP_ID_HH_
